import type { Base64EncodedWireTransaction, CompilableTransactionMessage, Transaction } from "@solana/kit";
/**
 * Compile a transaction to a base64 string
 *
 * Note: This will NOT attempt to sign the transaction,
 * so it will be missing `signatures` from any of the attached Signers
 *
 * Use {@link transactionToBase64WithSignatures} sign and base64 encode
 */
export declare function transactionToBase64(tx: CompilableTransactionMessage | Transaction): Base64EncodedWireTransaction;
/**
 * Compile a transaction to a base64 string and sign it with all attached Signers
 *
 * See also {@link partiallySignTransactionMessageWithSigners}
 */
export declare function transactionToBase64WithSigners(tx: CompilableTransactionMessage | Transaction): Promise<Base64EncodedWireTransaction>;
//# sourceMappingURL=base64-to-transaction.d.ts.map